--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/cnc1900_video.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/cnc1900_video.h	2014-08-27 20:38:14.286427000 +0800
@@ -0,0 +1,133 @@
+#ifndef __CNC1900_VIDEO_H__
+#define __CNC1900_VIDEO_H__
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define VIDEO_MAJOR 300
+
+#define VIDEO_MCU_REGION (VIDEO_STUFF_REGION)
+#define VIDEO_MCU_SIZE (0x80000)
+#define VIDEO_CODA_REGION (VIDEO_MCU_REGION+VIDEO_MCU_SIZE)
+#define VIDEO_CODA_SIZE (0x200000)
+#define VIDEO_CODA_OFFSET (VIDEO_CODA_REGION - VIDEO_MCU_REGION)
+#define VIDEO_HOST_IF_REGION (VIDEO_CODA_REGION +VIDEO_CODA_SIZE)
+#define VIDEO_HOST_IF_SIZE (0x80000)
+#define VIDEO_HOST_IF_OFFSET (VIDEO_HOST_IF_REGION - VIDEO_MCU_REGION)
+#define VIDEO_HOST_TO_VIDEO_MSG_REGION (VIDEO_HOST_IF_REGION +VIDEO_HOST_IF_SIZE)
+#define VIDEO_HOST_TO_VIDEO_MSG_SIZE (0x80000)
+#define VIDEO_HOST_TO_VIDEO_MSG_OFFSET (VIDEO_HOST_TO_VIDEO_MSG_REGION - VIDEO_MCU_REGION)
+#define VIDEO_VIDEO_TO_HOST_MSG_REGION (VIDEO_HOST_TO_VIDEO_MSG_REGION +VIDEO_HOST_TO_VIDEO_MSG_SIZE)
+#define VIDEO_VIDEO_TO_HOST_MSG_SIZE (0x80000)
+#define VIDEO_VIDEO_TO_HOST_MSG_OFFSET (VIDEO_VIDEO_TO_HOST_MSG_REGION - VIDEO_MCU_REGION)
+
+/* Need to check below */
+#define MIPS_ISRAM_MEM_SIZE	(1024 * 9)	/* 9KB */
+#define MIPS_DSRAM_MEM_SIZE	(1024 * 16)	/* 16KB */
+
+#define INST_OUT_MEM_SIZE	(1024 * 1)
+#define INST_MIPS_MEM_SIZE	(1024 * 8)
+
+#if (defined CONFIG_SW_SUPPORT)
+#define MIPS_ISRAM_OFFSET	(0xb1690000)
+#define MIPS_DSRAM_OFFSET	(0xb16A0000)
+#define MIPS_RESET_OFFSET	(0xb16B0000)
+#else
+#define MIPS_ISRAM_OFFSET	((0xb1690000 - CNC_VIDEO_REG_BASE) >> 2)
+#define MIPS_DSRAM_OFFSET	((0xb16A0000 - CNC_VIDEO_REG_BASE) >> 2)
+#define MIPS_RESET_OFFSET	((0xb16B0000 - CNC_VIDEO_REG_BASE) >> 2)
+#endif
+#define MEM_SWAP32(x)	( (((x) & 0xff) << 24) | (((x) & 0xff00) <<8) |	(((x) & 0xff0000) >> 8) | (((x) & 0xff000000) >> 24) )
+
+#define CSVID_IOC_GET_VIDEO_CPB_ADDR	        _IOW('z', 0x01, int)
+#define CSVID_IOC_GET_VIDEO_CPB_SIZE	        _IOW('z', 0x02, int)
+#define CSVID_IOC_GET_VIDEO_CPB_DIR_ADDR	    _IOW('z', 0x03, int)
+#define CSVID_IOC_GET_VIDEO_CPB_DIR_SIZE	    _IOW('z', 0x04, int)
+                                                
+#define CSVID_IOC_GET_VIDEO_HOST_IF_ADDR	    _IOW('z', 0x05, int)
+#define CSVID_IOC_GET_VIDEO_HOST_IF_SIZE	    _IOW('z', 0x06, int)
+#define CSVID_IOC_GET_VIDEO_REG_ADDR		    _IOW('z', 0x07, int)
+#define CSVID_IOC_GET_VIDEO_REG_SIZE		    _IOW('z', 0x08, int)
+                                                
+#define CSVID_IOC_GET_NOTIFY_TYPE	            _IOW('z', 0x09, int)
+#define CSVID_IOC_SET_NOTIFY_TYPE	            _IOW('z', 0x0a, int)
+                                                
+#define CSVID_IOC_GET_XPORT_VIDEO	            _IOW('z', 0x0b, int)
+#define CSVID_IOC_SET_VIB_PINMUX                _IOW('z', 0x0c, int)
+                                                
+#define CSVID_IOC_GET_VIDEO_UD_ADDR             _IOW('z', 0x0d, int)
+#define CSVID_IOC_GET_VIDEO_UD_SIZE             _IOW('z', 0x0e, int)
+                                                
+#define CSVID_IOC_RELOAD_FIRMWARE               _IOW('z', 0x0f, int)
+#define CSVID_IOC_GET_VIDEO_NUM	                _IOW('z', 0x10, int)
+                                                
+#define CSVID_IOC_SET_VIDEO_ALPHA               _IOW('z', 0x11, int)
+#define CSVID_IOC_GET_VIDEO_ALPHA               _IOR('z', 0x12, int)
+#define CSVID_IOC_GET_TG1_PIC_FORMAT            _IOR('z', 0x13, int)
+#define CSVID_IOC_GET_HD2SD_MODE                _IOR('z', 0x14, int)
+#define CSVID_IOC_GET_VIDEO_CODA_CLOCK          _IOR('z', 0x15, int)
+                                                
+#define CSVID_IOC_GET_VIDEO_CODA_ADDR	        _IOW('z', 0x20, int)
+#define CSVID_IOC_GET_VIDEO_DPB_ADDR	        _IOW('z', 0x21, int)
+#define CSVID_IOC_GET_VIDEO_DPB_SIZE	        _IOW('z', 0x22, int)
+#define CSVID_IOC_GET_HOST_TO_VIDEO_MSG_ADDR	_IOW('z', 0x23, int)
+#define CSVID_IOC_GET_HOST_TO_VIDEO_MSG_SIZE	_IOW('z', 0x24, int)
+#define CSVID_IOC_GET_VIDEO_TO_HOST_MSG_ADDR	_IOW('z', 0x25, int)
+#define CSVID_IOC_GET_VIDEO_TO_HOST_MSG_SIZE	_IOW('z', 0x26, int)
+
+#define CSVID_IOC_GET_VIDEO_ENC_NUM	            _IOW('z', 0x30, int)
+#define CSVID_IOC_GET_VIDEO_ENC_CPB_ADDR 	    _IOW('z', 0x31, int)
+#define CSVID_IOC_GET_VIDEO_ENC_CPB_SIZE 	    _IOW('z', 0x32, int)
+#define CSVID_IOC_GET_VIDEO_ENC_DIR_ADDR 	    _IOW('z', 0x33, int)
+#define CSVID_IOC_GET_VIDEO_ENC_DIR_SIZE 	    _IOW('z', 0x34, int)
+
+#define CSVID_IOC_GET_XPORT_SIZE	            _IOR('z', 0x35, int)
+#define CSVID_IOC_GET_XPORT_WPRP_ADDR	        _IOR('z', 0x36, int)
+#define CSVID_IOC_GET_XPORT_WPRP_SIZE	        _IOR('z', 0x37, int)
+
+#define CSVID_IOC_SET_VIDEO_START		        _IOW('z', 0xfe, int)
+
+//#define VIDEO_NOTIFY_TYPE_ENABLE 0x80000000
+//#define VIDEO_NOTIFY_TYPE_PICTURE_READY     (1<<0)
+//#define VIDEO_NOTIFY_TYPE_AV_SYNC           (1<<1)
+//#define VIDEO_NOTIFY_TYPE_ENC_FRAME_DONE    (1<<2)
+//#define VIDEO_NOTIFY_TYPE_TIMECODE 0x1
+//#define VIDEO_NOTIFY_TYPE_DECODERERROR 0x2
+//#define VIDEO_NOTIFY_TYPE_ASPECTRATIO 0x4
+//#define VIDEO_NOTIFY_TYPE_PANSCANCROP 0x8
+//#define VIDEO_NOTIFY_TYPE_SYNC1 0x10
+//#define VIDEO_NOTIFY_TYPE_SYNC2 0x20
+//#define VIDEO_NOTIFY_TYPE_UNDERFLOW 0x40
+//#define VIDEO_NOTIFY_TYPE_FORMATCHANGE 0x80
+//#define VIDEO_NOTIFY_TYPE_SRC_FORMATCHANGE 0x100
+//#define VIDEO_NOTIFY_TYPE_DECODE_FINISHED 0x200
+//
+
+//!!!Note: please must be to update kernel you will can properly to use video (decoder & encoder).
+/*Video interrupt type*/
+typedef enum _VID_INT_TYPE{
+    VID_INI_UNKNOWN        =  -1    ,
+    VID_INT_FW_ERROR       =  (1<<0),
+    VID_INT_CMD_ACK        =  (1<<1),
+    VID_INT_LOG_MESSAGE    =  (1<<2),
+    VID_INT_ENC_FRAME_DONE =  (1<<3),//encoder frame interrupt flags
+    VID_INT_MEM_ALLOC      =  (1<<4),
+    VID_INT_MEM_FREE       =  (1<<5),
+    VID_INT_FRAME_OUTPUT   =  (1<<6),
+    VID_INT_FRAME_RELEASE  =  (1<<7),
+    VID_INT_DEC_PIC_READY  =  (1<<8),//decoder frame interrupt flags
+    VID_INT_AV_SYNC_OK     =  (1<<9),//av sync interrupt flags
+    VID_INT_DISPLAY_VSYNC  =  (1<<10),//vsync from vpp
+    VID_INT_YUV_BUF_INFO   =  (1<<11),//YUV buffer info for playback
+    VID_INT_DEC_SEQ_CHANGE =  (1<<12),//Decoder sequence change
+
+    VID_INT_ENABLE         =  (1<<31),//interrupt enable bit
+}CSVID_INT;                  
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/Kconfig	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,82 @@
+
+menu "Celestial Video Drivers"
+
+if ARCH_CELESTIAL
+config CELESTIAL_VIDEO
+	bool "CNC1900 Video"
+	depends on ARCH_CELESTIAL
+	default y
+	help 
+	    Include support drvier for video of celestial platform.
+endif
+
+config VIDEO_DECODER
+	bool "Video Decoder"
+	depends on CELESTIAL_VIDEO
+	default y
+	help
+	    Enable video decoder. Some projects no need to decoder video date. It can be disabled for saving memory.
+
+config VIDEO_ENCODER
+	bool "Video Enocder"
+	depends on CELESTIAL_VIDEO
+	default n
+	help
+	    Enable video encoder. Some projects no need to encoder video date. It can be disabled for saving memory.
+
+config VIDEO_CODA_CLOCK
+	int "Video Coda clock"
+	depends on CELESTIAL_VIDEO
+	range 0 2
+	default 0
+	help
+	    The coda clock of video engine, default is 0.
+
+config VIDEO_NUM
+	int "Video Number"
+	depends on VIDEO_DECODER
+	range 1 2
+	default 1
+	help
+	    The number of video supported by video decoder, can be set to 1 or 2.
+
+config VIDEO_CPB_SIZE
+	hex "Video CPB Size"
+	depends on VIDEO_DECODER
+	range 0x400000 0x1000000
+	default 0x400000
+	help
+	    Compressed picture buffer size of one video, range from 0x400000 to 0xc00000.
+
+config VIDEO_ENC_NUM
+	int "Video Encoder Number"
+	depends on VIDEO_ENCODER
+	range 1 1
+	default 1
+	help
+	    The number of video supported by video encoder, can be set to 1.
+
+config VIDEO_ENC_CPB_SIZE
+	hex "Video Encoder CPB Size"
+	depends on VIDEO_ENCODER
+	range 0x400000 0x1000000
+	default 0x400000
+	help
+	    Compressed picture buffer size of one video, range from 0x400000 to 0xc00000.
+
+config CELESTIAL_VIDEO_DEBUG
+	bool "Video Debugging"
+	depends on CELESTIAL_VIDEO
+	help
+	    This turns on low-level debugging for the celestial video driver.
+	    Normally, you should say 'N'.
+
+
+config VIDEO_DEBUG_VERBOSE
+	int "VIDEO Debugging verbosity (0 = quiet, 3 = noisy)"
+	depends on CELESTIAL_VIDEO_DEBUG
+	default "0"
+	help
+	    Determines the verbosity level of the video debugging messages.
+
+endmenu
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,6 @@
+#
+# Makefile for the linux kernel.
+# 
+#
+obj-$(CONFIG_MACH_CELESTIAL_CNC1900) += cnc1900_video.o
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/video_handshake_def.h linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/video_handshake_def.h
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/video_handshake_def.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/video_handshake_def.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,569 @@
+
+#ifndef _FW_ATTR_H_ 
+#define _FW_ATTR_H_
+#ifdef __cplusplus
+extern "C"{
+#endif
+
+/*FPGA related definition*/
+//#define MIPS_RUN 1
+//
+//#define VIDEO_CODA  1
+//#define VIDEO_VPP 1
+//#define VIDEO_VPB 1
+//#define INT_CONTROLLER 1
+//#define HAND_BY_SEM 0 //set to '1' to support mips run without VPP
+//#define UES_OLD_CMD 0
+//#define VPP_CONFIG_DYN   1
+//
+//==============================================================================
+
+#define MAX_WIN_NUM   4
+#define DEC_CPB_NUM   4
+#define ENC_CPB_NUM   4
+#define VPB_NUM       1
+#define CAP_NUM        1
+#define ROT_NUM       1
+#define SRC_BUF_NUM   (DEC_CPB_NUM + VPB_NUM+CAP_NUM)
+
+#define SRC_BUF_MASK ((1<<SRC_BUF_NUM) - 1)
+
+//==============================================================================
+typedef enum
+{
+    CH_CPB0,
+    CH_CPB1,
+    CH_CPB2,
+    CH_CPB3,
+    CH_VPB0,
+    CH_CAP0
+}ChannelDecT;
+
+typedef enum
+{
+    CH_ENC0,
+    CH_ENC1,
+    CH_ENC2,
+    CH_ENC3
+}ChannelEncT;
+
+typedef enum {
+    VID_WINDOW_DEST_TG1 = 0,
+    VID_WINDOW_DEST_TG2,
+    VID_WINDOW_DEST_ENC0,
+    VID_WINDOW_DEST_ENC1,
+    VID_WINDOW_DEST_ENC2,
+    VID_WINDOW_DEST_ENC3,
+    VID_WINDOW_DEST_INVALID = 0xff
+} VidWindowDestT;
+
+typedef enum {
+    VID_WINDOW_SRC_CPB0 = 0,
+    VID_WINDOW_SRC_CPB1,
+    VID_WINDOW_SRC_CPB2,
+    VID_WINDOW_SRC_CPB3,
+    VID_WINDOW_SRC_VPB,
+    VID_WINDOW_SRC_CAP_TG1,
+    VID_WINDOW_SRC_CAP_EXT
+} VidWindowSrcT;
+
+typedef enum
+{
+    LAYER_HWSEL_NONE=0,
+    LAYER_HWSEL_SR,
+    LAYER_HWSEL_MAIN,
+    LAYER_HWSEL_RD2,
+    LAYER_HWSEL_DMA,
+    LAYER_HWSEL_CAP,
+    LAYER_HWSEL_VPB,
+    LAYER_HWSEL_DEC,
+    LAYER_HWSEL_ENC,
+    LAYER_HWSEL_NUM
+}LayerHwSelT;
+
+typedef enum
+{
+    FORMAT_2D, //normal 2D progressive or line-interleaved interlaced video
+    FORMAT_SBS, //normal 3D side-by-side progressive or line-interleaved interlaced video
+    FORMAT_TAB, //normal 3D top-and-bottom progressive video
+    FORMAT_FP, //normal 3D frame packing, left & right eye separated frame
+    FORMAT_PV_FP_2D_I, //PureVu 2D frame-packing (interlaced), top/bottom field separated
+    FORMAT_PV_FP_3D //PureVu 3D frame-packing, left & right eye packed in one frame
+}Format3DT;
+
+typedef enum
+{
+    PLAY_MODE_STOP = 0,
+    PLAY_MODE_RUN,
+    PLAY_MODE_PAUSE,
+    PLAY_MODE_FREEZE,
+    PLAY_MODE_STEP
+}PlayModeT;
+
+typedef enum
+{
+    ENC_MODE_STOP = 0,
+    ENC_MODE_RUN
+}EncModeT;
+
+typedef enum
+{
+    UPDATE_PLAY_CMD = 0,
+    UPDATE_REC_CMD,
+    UPDATE_DEBUG_CMD,
+    UPDATE_TG_CHG_CMD,
+    UPDATE_CODA_RESET_CMD
+}UpdateCmdType;
+
+typedef enum
+{
+    DECODE_IPB = 0,
+    DECODE_I,
+    DECODE_IP,
+    DECODE_NONE
+}DecModeT;
+
+typedef enum
+{
+    PLAY_SPEED_1_32 = 0,
+    PLAY_SPEED_1_16,
+    PLAY_SPEED_1_8,
+    PLAY_SPEED_1_4,
+    PLAY_SPEED_1_2,
+    PLAY_SPEED_NORMAL,
+    PLAY_SPEED_2,
+    PLAY_SPEED_4,
+    PLAY_SPEED_8,
+    PLAY_SPEED_16,
+    PLAY_SPEED_32
+}PlaySpeedT;
+
+typedef enum
+{
+    VID_CODEC_STD_AVC = 0,
+    VID_CODEC_STD_VC1,
+    VID_CODEC_STD_MPEG2,
+    VID_CODEC_STD_MPEG4,
+    VID_CODEC_STD_H263,
+    VID_CODEC_STD_DIV3,
+    VID_CODEC_STD_RV,
+    VID_CODEC_STD_AVS,
+    VID_CODEC_STD_MJPG,
+    VID_CODEC_STD_THO = 9,
+    VID_CODEC_STD_VP3,
+    VID_CODEC_STD_VP8,
+    VID_CODEC_STD_MVC,
+    VID_CODEC_STD_UNKNOW = 0xff
+} VidCodecStdT;
+
+typedef enum
+{
+    LLD_DISABLE = 0,
+    LLD_PARTIAL_FRAME_MODE = (1<<0), //start display earlier. Only support H.264. NOTE:reorder will be off
+    LLD_STREAM_LOW_DELAY_MODE = (1<<1) //start decoding earlier.
+}LowLatencyDecModeT;
+
+//==============================================================================
+typedef enum
+{
+    DEBUG_BITSTREAM_STATUS = 0,
+    DEBUG_MIPS_READ_DATA,
+    DEBUG_MIPS_WRITE_ADDR,
+    DEBUG_MIPS_WRITE_DATA,
+    DEBUG_MIPS_LOG_ADDR,
+    DEBUG_VPP_MEM_USAGE,
+    DEBUG_FIFO_STATUS,
+    DEBUG_FIFO_OPEN,
+    DEBUG_FIFO_PUSH,
+    DEBUG_FIFO_POP,
+    DEBUG_FIFO_CLOSE,
+    DEBUG_FIFO_READ,
+    DEBUG_LOG_ENABLE,
+    DEBUG_MIPS_TEST
+}HostDebugCmdT;
+
+typedef enum
+{
+    VID_FW_STACK_OVERFLOW = 0,  //MIPS firmware stack overflow.
+    VID_MEM_OVERFLOW,           //Picture buffer memory overflow.
+    VID_MEM_CONFIG_INVALID,     //Host configured memory with invalid parameters such as alignment, 420/422 size etc.
+    VID_DEC_FATAL_ERR,          //Fatal error of VPU that current channel must be closed.
+    VID_DEC_SEQ_INIT_TIMEOUT,   //Could not find sequence header for decoder.
+    VID_DEC_SEQ_INIT_FAIL,      //Sequence header decode fail.
+    VID_DEC_TOO_MANY_REF_FRAMES,//Too many reference frames for decoder.
+    VID_DEC_FRAME_ERR,          //Error detected in the current frame for decoder.
+    VID_DEC_EOF,                //EOF detected and decoder will be closed.
+    VID_DEC_TIMEOUT,            //VPU timeout during frame decoding. Need to be reset.
+    VID_ENC_FATAL_ERR,          //Fatal error of VPU that current channel must be closed.
+    VID_ENC_TOO_MANY_REF_FRAMES,//Too many reference frames for encoder.
+    VID_ENC_TIMEOUT,            //VPU timeout during frame encoding. Need to be reset.
+    VID_VPP_CONFIG_INVALID      //Invalid parameters for VPP.
+}VidFwErrorTypeT;
+
+typedef struct
+{
+    unsigned char PlayMode:3;
+    unsigned char PlaySpeed:5;
+}PlayCtrlCmdT;
+
+//==============================================================================
+
+typedef struct
+{
+    unsigned int   Format3D:4; 		//2D, SbS, TaB, FP, PVFP-2D-i, PVFP-3D
+    unsigned int   IsInterlace:1;
+    unsigned int   HorSample:1;
+    unsigned int   VerSample:1;
+    unsigned int   TopFieldFirst:1;
+    unsigned int   VactSpace1:8;		//for interlace or progressive frame packing, see HDMI Spec
+    unsigned int   VactSpace2:8;		//for interlace frame packing, see HDMI Spec
+    unsigned int   PicWidth:16;
+    unsigned int   PicHeight:16;
+    unsigned int   FrameRate;
+}PicFormatT;
+
+//==============================================================================
+
+typedef struct
+{
+    unsigned int Pts;
+    unsigned int EsByteCounter; 
+    unsigned int Eof:1;
+    unsigned int Rotate:2;
+    unsigned int Mirror:2;
+    unsigned int SubPicLast:1;   
+    unsigned int SubPicStartX:13;
+    unsigned int SubPicStartY:13;
+    unsigned int Reserved;
+}PtsFifoT;
+
+typedef struct
+{
+    unsigned int Pts;
+    unsigned int EsByteCounter; 
+    unsigned int Reserved0;
+    unsigned int Reserved1;
+}EncCpbPtsFifoT; 
+
+//==============================================================================
+
+typedef struct
+{
+    unsigned int YTnrEn:1;
+    unsigned int YTnrGate:6;
+    unsigned int YTnrDiv:2;
+    unsigned int CTnrEn:1;
+    unsigned int CTnrGate:6;
+    unsigned int CTnrDiv:2;
+}MainT;
+
+typedef struct
+{
+    unsigned char SrK;
+}SrT;
+
+typedef struct
+{
+    unsigned int BgY:10;
+    unsigned int BgU:10;
+    unsigned int BgV:10;
+    unsigned char  V1Order: 2;
+    unsigned char  V2Order: 2;
+    unsigned char  G1Order: 2;
+    unsigned char  G2Order: 2;
+    /*
+    unsigned short StartX;
+    unsigned short StartY;
+    unsigned short EndX;
+    unsigned short EndY;
+    */
+}BlendT;
+
+typedef struct
+{
+    unsigned int Bright:8;
+    unsigned int Contrast:6;
+    unsigned int Saturation:8;
+    unsigned int sharp_en:1;
+}ColorT;
+
+typedef enum
+{
+    TG_ID1=0,
+    TG_ID2,
+    TG_NUM
+}TG_ID;
+
+typedef enum
+{
+    BLEND_ID1=0,
+    BLEND_ID2,
+    BLEND_ID3,
+    BLEND_NUM
+}BLEND_ID;
+
+typedef enum
+{
+    UI_ID1=0,
+    UI_ID2,
+    UI_NUM
+}UI_ID;
+
+ 
+
+typedef struct
+{
+    MainT Main;
+    SrT Sr;
+    //BlendT Blend[BLEND_NUM];
+    //ColorT Color;
+ }SocAttrT;
+
+//==============================================================================
+typedef enum
+{
+    INT_DISABLE=0,
+    INT_ENABLE
+}IntMode;
+typedef struct
+{
+    //unsigned int CodaBitCodeAddr;
+    unsigned int VppBufAddr;
+    unsigned int VppBufSize;
+    unsigned int FwUploadMsgBufAddr;
+    unsigned int FwUploadMsgBufSize;
+    unsigned int FwDownloadMsgBufAddr;
+    unsigned int FwDownloadMsgBufSize;
+    unsigned int HdPicHeight:12;
+    unsigned int V420BlockNum:8;
+    unsigned int DecIntMode:1;
+    unsigned int VppIntMode:1;
+    unsigned int VpbIntMode:1;
+    unsigned int SubPicAppEn:1;//Only for acer project
+    unsigned int VppMainForceF2fEn:1; //for multi-win case
+    unsigned int AddrDynAllocSwitch:1;//Dynamic allocate address switch
+    unsigned int AvSyncByHostSwitch:1;//Av sync by host switch.
+    unsigned int CodaProfileEn:1;
+    unsigned int Hd2SdEn:1;
+}FwAttrT;
+
+//==============================================================================
+typedef struct
+{
+    unsigned short AvsyncEn:1;
+    unsigned short AvsyncByFrc:1;
+    unsigned short NoAudio:1;
+    unsigned short AvDelay:13;    //--TBD
+}AvSyncAttrT;
+
+typedef struct
+{
+    unsigned int HorSyncPolarity:1; //0: high pulse, 1: low pulse
+    unsigned int VerSyncPolarity:1; //0: high pulse, 1: low pulse
+    unsigned int FldSyncPolarity:1; //0: high pulse, 1: low pulse
+    unsigned int SyncMode:2;        //0: embedded sync, 1: separate sync (H/V), 2: DE only mode, 3: SMPTE
+    unsigned int IsHd:1;
+    unsigned int RgbMode:1;
+    unsigned int BodaFormat:1;
+    unsigned int InterfBitWidth:2;//0: 8-bit interface, 1: 16-bit interface, 2: 24-bit interface
+    unsigned int HorSyncPulse:8;
+    unsigned int VerSyncPulse:8;
+    unsigned int StartEncThres:7; //Threshold to begin encoding the frame (in unit of MB rows).
+
+    unsigned int PixelFreqHz;
+    unsigned int HorFrontPorch:16;   
+    unsigned int HorBackPorch:16;
+    unsigned int VerFrontPorch:16;  
+    unsigned int VerBackPorch:16;      
+} VpbDetailFormatT;
+
+typedef struct
+{
+    VpbDetailFormatT VpbDetailFormat;
+}VpbAttrT;
+
+typedef struct
+{
+    unsigned int DecMode:2; //DecModeT
+    unsigned int DecFile:1;
+    unsigned int CodecStd:4;
+    unsigned int LowLatencyMode:3; //set LowLatencyDecModeT
+    unsigned int LowLatencyMbRowPercent:7; //0~100 to represent 0 to full frame
+    unsigned int ReserveBufAtClose:1; //do not release buffer at close for display or switch reason
+    unsigned int DecOneJpeg:1;
+    unsigned int RotationEnable:1;
+    unsigned int ReorderEnable:1;
+    unsigned int StreamEndFlag:1;
+    unsigned int JpegFrameAddr;
+    unsigned int PtsFifoStartAddr;
+    unsigned int PtsFifoEndAddr;
+    unsigned int EsFifoStartAddr;
+    unsigned int EsFifoEndAddr;
+    unsigned int MjpgEsFifoStartAddr;
+    unsigned int MjpgEsFifoEndAddr;
+}DecCpbAttrT;
+
+//==============================================================================
+
+typedef struct{
+    unsigned int sliceMode:1;    //0: one slice per picture; 1: multiple slices per picture.
+    unsigned int sliceSizeMode:1;//0 means the sliceSize is defined by the amount of bits, and 1 means the sliceSize is defined by the number of MBs.
+    unsigned int sliceSize:30;   //size of a slice in bits or in MB numbers included in a slice
+} EncSliceModeT;
+
+typedef struct
+{
+    unsigned char Mp4_DataPartitionEn:1;
+    unsigned char Mp4_RvlcEn:1;
+}EncMp4ParamT;
+
+typedef struct
+{
+    unsigned char H263_AnnexIEn:1;
+    unsigned char H263_AnnexJEn:1;
+    unsigned char H263_AnnexKEn:1;
+    unsigned char H263_AnnexTEn:1;
+}EncH263ParamT;
+
+typedef struct
+{
+    unsigned int Avc_DisableDeblocking:1;
+}EncAvcParamT;
+
+typedef struct
+{
+    unsigned char Mjpg_SrcFormat; //0-4:2:0, 1-4:2:2 horizontal, 2-4:2:2 vertical, 3-4:4:4, 4-4:0:0
+    unsigned char *HuffVal;	
+	unsigned char *HuffBits;	
+	unsigned char *QMatTab;
+	unsigned char *CInfoTab;
+}EncMjpgParamT;
+
+typedef struct
+{
+    int FrameRateInfo;
+    unsigned int BitRate:16; // Maximum bitrate value is 65535 kbps. 0 to disable rc.
+    unsigned int IntraRefresh:16;
+    unsigned int RateCtrlMode:2; // rate control enable (0:constant QP, 1:CBR, 2:ABR)
+    unsigned int QpY:6;      // 1~31 for MPEG4; 0~51 for H.264
+    unsigned int EnableAutoSkip:1;
+    unsigned int GopSize:15; //Maximum value will be 32767.
+    unsigned int MeSearchRangeX:2; // 0:(-64~63) 1:(-48~47) 2:(-32~31) 3:(-16~15)
+    unsigned int MeSearchRangeY:2; // 0:(-48~47) 1:(-32~31) 2:(-16~15)
+    unsigned int Profile:2; //H.264: 0:BP 1:MP 2:HP  MPEG4:ignored
+    EncSliceModeT EncSliceMode;
+    union {
+		EncMp4ParamT Mp4Param;
+		EncH263ParamT H263Param;
+		EncAvcParamT AvcParam;
+		EncMjpgParamT MjpgParam;  	
+	} EncStdParam;
+}EncOpenParamT;
+
+typedef struct
+{
+    unsigned int SrcBufNo:8;//DpbBufNo:8;
+    unsigned int CodecStd:4;
+    unsigned int SubFrameSyncEn:1;
+    unsigned int EncOneJpeg:1;
+    unsigned int JpegFrameAddr;
+    unsigned int PtsFifoStartAddr;
+    unsigned int PtsFifoEndAddr;
+    unsigned int EsFifoStartAddr;
+    unsigned int EsFifoEndAddr;
+    unsigned int MjpgEsFifoStartAddr;
+    unsigned int MjpgEsFifoEndAddr;
+    PicFormatT PicFormat;
+    EncOpenParamT EncOpenParam;
+}EncCpbAttrT;
+/********************************new achitecture******************************/
+typedef enum//f2d,f2f,d2f must be that order
+{
+    WIN_F2D_SR=0,
+    WIN_F2D_MAIN,
+    WIN_F2D_RD2,
+    WIN_F2F_MAIN_IDX0,
+    WIN_F2F_MAIN_IDX1,
+    WIN_F2F_MAIN_IDX2,
+    WIN_F2F_MAIN_IDX3,
+    WIN_F2F_DMA,
+    WIN_D2F_CAP,
+    WIN_D2F_VPB,
+    WIN_NUM
+}WinNoT;
+typedef enum
+{
+    BUF_DEC_IDX0=0,
+    BUF_DEC_IDX1,
+    BUF_DEC_IDX2,
+    BUF_DEC_IDX3,
+    BUF_VPB,
+    BUF_CAP,
+    BUF_F2F_MAIN_IDX0,
+    BUF_F2F_MAIN_IDX1,
+    BUF_F2F_MAIN_IDX2,
+    BUF_F2F_MAIN_IDX3,
+    BUF_F2F_MAIN_TG1MUL,
+    BUF_F2F_DMA,
+    BUF_TG1,
+    BUF_TG2,
+    BUF_ENC_IDX0,
+    BUF_ENC_IDX1,
+    BUF_ENC_IDX2,
+    BUF_ENC_IDX3,
+    BUF_EXT,
+    BUF_ROT_IDX0,
+    BUF_ROT_IDX1,
+    BUF_ROT_IDX2,
+    BUF_ROT_IDX3,
+    BUF_NUM
+}BufNoT;
+typedef struct
+{
+    unsigned short StartX;
+    unsigned short EndX;
+    unsigned short StartY;
+    unsigned short EndY;
+}WinRectT;
+typedef struct
+{
+    unsigned char En:1;
+    unsigned char HwSel:3;								//f2d: tg1(main/sr)/tg2(rd2); f2f: main/dma; d2f: vpb/cap; together 6(main/sr/dma/rd2/cap/vpb)
+    unsigned char F2fOrder:4;
+    unsigned char AlphaEn; //windows alpha , 1:en,0:dis,default 1. add by wanglixin
+    unsigned char SrcBufNo;						//d2f: see tg1/ext as buf
+    unsigned char DesBufNo;						//f2d: see tg1/tg2 as buf
+    WinRectT Src;
+    WinRectT Des;
+}VppWinAttrT;
+
+typedef struct
+{
+    PicFormatT PicFormat;
+    AvSyncAttrT AvSyncAttr; //En just for DecBuf[DecMax] & DmaBuf[1]******
+}VppBufAttrT;
+
+typedef struct
+{
+    SocAttrT SocAttr;
+    FwAttrT FwAttr;
+    DecCpbAttrT DecCpbAttr[DEC_CPB_NUM];
+    EncCpbAttrT EncCpbAttr[ENC_CPB_NUM];
+    VpbAttrT VpbAttr[VPB_NUM];
+    VppWinAttrT VppWinAttr[WIN_NUM];
+    VppBufAttrT VppBufAttr[BUF_NUM];
+}DdrFwAttrT;
+
+//==============================================================================
+
+//extern DdrFwAttrT DdrFwAttr;
+//extern PlayCtrlCmdT PlayCtrlCmd[SRC_BUF_NUM];
+
+//==============================================================================
+
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/video_reg_def.h linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/video_reg_def.h
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/video_reg_def.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/video_reg_def.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,94 @@
+#ifndef _VIDEO_REG_DEF_H_
+#define _VIDEO_REG_DEF_H_
+
+#ifdef __cplusplus
+extern "C"{
+#endif
+
+#define CNC_VIDEO_REG_BASE (0xb1600000)
+#define CNC_VIDEO_REG_SIZE	(0x100000)
+#define CNC_INT_REG_BASE            (0xb1c10000)
+#define CNC_INT_REG_SIZE            (0x1000)
+/*mailbox*/
+#define VID_MIPS_MAILBOX(n)         (CNC_VIDEO_REG_BASE + ((n)<<2))
+
+
+/*  dma */
+#define REG_DMA_BASE                (0x20c000)
+#define REG_DMA_LEN                 (REG_DMA_BASE + (0x1 << 2))
+#define REG_DMA_CMD                 (REG_DMA_BASE + (0x2 << 2))
+#define REG_DMA_STATUS              (REG_DMA_BASE + (0x3 << 2))
+
+#define REG_DMA_BUFFER0             (0x20e000)
+#define REG_DMA_BUFFER1             (0x20f000)
+
+/*ARM write mailbox update flag masks*/
+#define BIT_UPDATE_FLAG                 ((unsigned int)(1<<31))
+
+/*ARM read mailbox update flag masks*/
+
+/*ARM write mailbox list*/
+#define MAILBOX_FW_ATTR_UPDATE_FLAG     (VID_MIPS_MAILBOX(0))
+#define MAILBOX_FIRMWARE_CONFIG_BADDR   (VID_MIPS_MAILBOX(1))
+#define MAILBOX_DEC_CPB_WPRP_BADDR      (VID_MIPS_MAILBOX(2)) //ES_RP/WP, PTS_RP/WP
+#define MAILBOX_ENC_CPB_WPRP_BADDR      (VID_MIPS_MAILBOX(3)) //ES_RP/WP, PTS_RP/WP
+#define MAILBOX_CODAFW_CONFIG_BADDR     (VID_MIPS_MAILBOX(4))
+#define MAILBOX_CMD_UPDATE_FLAG         (VID_MIPS_MAILBOX(5))//BIT[31] - Update Flag; BIT[0:30] - Update CMD Type
+#define MAILBOX_CMD_UPDATE_MSG          (VID_MIPS_MAILBOX(6))//BIT[24:31] - CH; BIT[0:23] - CMD
+#define MAILBOX_INT_MSG_UPDATE_FLAG     (VID_MIPS_MAILBOX(7))//BIT[31] - Update Flag; BIT[0:30] - Update MSG Type
+#define MAILBOX_DEBUG_CMD_UPDATE_FLAG   (VID_MIPS_MAILBOX(8))//BIT[31] - Update Flag; BIT[0:30] - Update CMD Type
+#define MAILBOX_DEBUG_CMD_UPDATE_MSG    (VID_MIPS_MAILBOX(9))//BIT[24:31] - CH; BIT[0:23] - CMD
+#define MAILBOX_CMD_DEBUG_PARAM1        (VID_MIPS_MAILBOX(10))
+#define MAILBOX_CMD_DEBUG_PARAM2        (VID_MIPS_MAILBOX(11))
+
+
+/*ARM read mailbox list*/
+#define MAILBOX_FIRMWARE_VERSION        (VID_MIPS_MAILBOX(17))
+#define MAILBOX_CODA_VERSION            (VID_MIPS_MAILBOX(18))
+#define MAILBOX_MIPS_DEBUG_FEEDBACK1    (VID_MIPS_MAILBOX(19))
+#define MAILBOX_MIPS_DEBUG_FEEDBACK2    (VID_MIPS_MAILBOX(20))
+#define MAILBOX_FW_LOG_BADDR            (VID_MIPS_MAILBOX(21))
+#define MAILBOX_FW_LOG_UPDATE_FLAG      (VID_MIPS_MAILBOX(22))
+#define MAILBOX_INT_TYPE                (VID_MIPS_MAILBOX(23))
+#define MAILBOX_VIDEO_PTS               (VID_MIPS_MAILBOX(24))
+
+#define MAILBOX_STATIC_BUF_ADDR   		(VID_MIPS_MAILBOX(32))
+#define MAILBOX_PIC_MEM_SIZE   			(VID_MIPS_MAILBOX(33))
+
+#define MAILBOX_MIPS_TIME               (VID_MIPS_MAILBOX(62))
+#define MAILBOX_MIPS_HEART_BEAT         (VID_MIPS_MAILBOX(63))
+
+/*misc*/
+//#define VID_CPBRP0                  (VIDEO_REG_ADDR_BASE + (0x40<<2) )
+//#define VID_CPBWP0                  (VIDEO_REG_ADDR_BASE + (0x41<<2) )
+//#define VID_HISTC                   (VIDEO_REG_ADDR_BASE + (0x42<<2) )
+//#define VID_STC0                    (VIDEO_REG_ADDR_BASE + (0x43<<2) )
+//#define VID_CPBRP1                  (VIDEO_REG_ADDR_BASE + (0x44<<2) )
+//#define VID_CPBWP1                  (VIDEO_REG_ADDR_BASE + (0x45<<2) )
+//#define VID_PTS_DIFF_TO_AUDIO       (VIDEO_REG_ADDR_BASE + (0x46<<2) )
+//#define VID_STC_DIFF_ADDR_AUDIO     (VIDEO_REG_ADDR_BASE + (0x47<<2) )
+//#define VID_WR_TO_AUDIO1            (VIDEO_REG_ADDR_BASE + (0x48<<2) )
+//#define VID_RD_FROM_AUDIO1          (VIDEO_REG_ADDR_BASE + (0x49<<2) )
+
+/*interrupt controller*/
+#define  INT_RISCCPU_EN                 (CNC_INT_REG_BASE+(0x00))
+#define  INT_RISCCPU_MASK               (CNC_INT_REG_BASE+(0x08))
+#define  INT_RISCCPU_FORCE              (CNC_INT_REG_BASE+(0x10))
+#define  INT_RISCCPU_FINALSTATUS        (CNC_INT_REG_BASE+(0x30))
+#define  INT_COPSW_EN                   (CNC_INT_REG_BASE+(0xc0))
+#define  INT_COPSW_MASK                 (CNC_INT_REG_BASE+(0xc4))
+#define  INT_COPSW_FORCE                (CNC_INT_REG_BASE+(0xc8))
+#define  INT_COPSW_FINALSTATUS          (CNC_INT_REG_BASE+(0xd4))
+
+#define  INT_COPSW_EN_OFFSET            (0xc0)
+#define  INT_COPSW_MASK_OFFSET          (0xc4)
+#define  INT_COPSW_FORCE_OFFSET         (0xc8)
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
+
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/Kconfig	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,29 @@
+# drivers/celestial/xport/Kconfig
+
+menu "Celestial Xport Drivers"
+
+
+config CELESTIAL_XPORT
+	bool "Xport drive"
+	depends on ARCH_CELESTIAL
+	default n
+	help
+	Include support driver for Xport of celestial platform
+
+config CELESTIAL_XPORT_DEBUG
+	bool "Debugging"
+	depends on CELESTIAL_XPORT
+	help
+	This turns on low-level debugging for the celestial xport driver.
+	Normally, you should say 'N'.
+
+
+config XPORT_DEBUG_VERBOSE
+	int "Debugging verbosity (0 = quiet, 3 = noisy)"
+	depends on CELESTIAL_XPORT_DEBUG
+	default "0"
+	help
+	Determines the verbosity level of the xport debugging messages.
+
+
+endmenu
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,7 @@
+#
+# Makefile for the linux kernel
+
+ifdef CONFIG_CELESTIAL_XPORT
+obj-$(CONFIG_ARCH_CELESTIAL) +=xport_filter1900.o xport_mips1900.o
+obj-$(CONFIG_MACH_CELESTIAL_CNC1900) +=xport_dma1900.o xport_drv1900.o 
+endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_dma1900.c linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_dma1900.c
